/*
 * uty.c
 *
 * All rights reserved. Copyright (C) 1994,1997 by NARITA Tomio
 */

#include <stdlib.h>
#include <stdio.h>

#ifdef MSDOS
#include <dos.h>
#endif /* MSDOS */

#include <import.h>
#include <itable.h>
#include <begin.h>
#include <uty.h>

public ic_t BinarySearch( codes_t *array, int high, ic_t code )
{
  int low, mid;

  low = 0;
  mid = high >> 1;

  for( ; low <= high ; mid = ( low + high ) >> 1 ){
    if( array[ mid ].code == code ){
      return array[ mid ].peer;
    } else if( array[ mid ].code > code ){
      high = mid - 1;
    } else {
      low = mid + 1;
    }
  }

  return 0;
}

public ic_t BinarySearchCset( codes_cset_t *array, int high, ic_t code,
			     char *cset )
{
  int low, mid;

  low = 0;
  mid = high >> 1;

  for( ; low <= high ; mid = ( low + high ) >> 1 ){
    if( array[ mid ].code == code ){
      *cset = array[ mid ].cset;
      return array[ mid ].peer;
    } else if( array[ mid ].code > code ){
      high = mid - 1;
    } else {
      low = mid + 1;
    }
  }

  return 0;
}

public void NotEnoughMemory()
{
  fprintf( stderr, "lv: not enough memory\n" ), exit( -1 );
}

public void FatalErrorOccurred()
{
  fprintf( stderr, "lv: fatal error occurred\n" ), exit( -1 );
}

public void *Malloc( unsigned int size )
{
  void *ptr;

  if( NULL == (ptr = malloc( size )) )
    NotEnoughMemory();

  return ptr;
}

#ifdef MSDOS
public void far *FarMalloc( unsigned int size )
{
  union REGS regs;

  regs.h.ah = 0x48;
  if( size & 0x000f )
    regs.x.bx = 1 + ( size >> 4 );
  else
    regs.x.bx = size >> 4;

  intdos( &regs, &regs );

  if( 0x0001 & regs.x.flags ){
    if( 0x08 == regs.x.ax )
      NotEnoughMemory();
    else
      FatalErrorOccurred();
  }

  return MK_FP( regs.x.ax, 0 );
}

public void FarFree( void far *ptr )
{
  union REGS regs;

  regs.h.ah = 0x49;
  regs.x.es = FP_SEG( ptr );

  intdosy( &regs, &regs );

  if( 0x0001 & regs.x.flags )
    FatalErrorOccurred();
}
#endif /* MSDOS */
